<template>
  <v-page :headerText="headerText">
    <v-retry-button v-if="error" @click="loadDevices"/>
    <div v-if="!error">
      <ul class="device-list">
        <li v-for="(device, index) in devices" :key="index" @click="onDeviceChosen(device)">
          <StatusLabel/>
          &nbsp;
          {{ device.name }}
          <font-awesome-icon icon="pen" class="button-edit" @click.stop="onEdit(device)"/>
        </li>
      </ul>
      <v-button
          :in-progress="inProgress"
          :type="ButtonType.SUCCESS"
          class="button"
          @click="onAddDevice"
      >
        Add device
      </v-button>
    </div>
    <v-button-link
        to="/user-auth"
        @click="onSignOut"
    >
      sign out
    </v-button-link>
  </v-page>
</template>

<script>
  import { FontAwesomeIcon } from '@fortawesome/vue-fontawesome'
  import { library } from '@fortawesome/fontawesome-svg-core'
  import { faPen } from '@fortawesome/free-solid-svg-icons'
  import { createNamespacedHelpers } from 'vuex'

  import { ButtonType, StatusLabel, VButton, VButtonLink, VPage } from 'zeus-common'
  import { signOut } from '@/common/auth'
  import VRetryButton from 'zeus-common/src/component/button/VRetryButton'
  import { headerText } from '@/config'
  import { ChooseDeviceService } from '@/pages/choose-device/service'

  library.add(faPen)

  const { mapState } = createNamespacedHelpers('chooseDevice')

  export default {
    name: 'ChooseDevicePage',
    components: { VRetryButton, FontAwesomeIcon, StatusLabel, VButton, VButtonLink, VPage },
    data: () => ({
      headerText: headerText,
      ButtonType: ButtonType
    }),
    computed: {
      ...mapState([ 'inProgress', 'error' ]),
      devices() {
        return this.$store.state.chooseDevice.devices.map(device => ({
          ...device,
          name: shortName(device.name)
        }))
      }
    },
    beforeMount() {
      this.loadDevices()
    },
    watch: {
      devices(devices) {
        if (devices.length === 0) {
          this.onAddDevice()
        }
      }
    },
    methods: {
      onAddDevice() {
        this.$store.commit('addDevice/setDeviceCount', this.devices.length)
        this.$router.push(`/add-device`)
      },
      onEdit(device) {
        this.$store.commit('editDevice/setDevice', { ...device, tags: device.tags.join(', ') })
        this.$router.push(`/edit-device`)
      },
      onDeviceChosen(device) {
        ChooseDeviceService.chooseDevice(device)
      },
      loadDevices() {
        if (this.error) {
          this.$store.commit('chooseDevice/resetError')
        }
        this.$store.dispatch('chooseDevice/loadDevices')
      },
      onSignOut: signOut
    }
  }

  function shortName(name) {
    const MAX_LENGTH = 25;
    return name.length > MAX_LENGTH ? name.substr(0, MAX_LENGTH) + '...' : name
  }
</script>

<style scoped lang="scss">
  @import "~zeus-common/src/component/color";
  @import "component/border-bottom";
  @import "component/dark-theme";

  .device-list {
    margin-top: -0.3em;
    margin-bottom: 1.4em;

    li {
      cursor: pointer;
      list-style-type: none;
      margin-left: -2.5em;
      padding-left: 1.5em;

      @include border-bottom(1px, 61%, #D4D4D4);

      padding-top: 0.55em;
      padding-bottom: 0.6em;

      &:last-child {
        border-bottom-width: 0;
      }

      .button-edit {
        $icon-size: 0.75em;

        display: inline-block;
        float: right;
        padding: 0.75em;
        margin-top: -0.55em;
        width: $icon-size;
        height: $icon-size;
        color: #D1D1D1;

        &:hover {
          background-color: #E8E8E8;
        }
      }

      &:hover {
        background-color: #F6F6F6;

        .button-edit {
          color: $color-text;
        }
      }
    }
  }

  .button {
    margin-top: 0.3em;
  }
</style>